<?php
/**
 * $Horde: jonah/delivery/rss.php,v 1.16 2006/01/01 21:10:52 jan Exp $
 *
 * Copyright 2003-2006 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you did not
 * receive this file, see http://cvs.horde.org/co.php/jonah/LICENSE.
 */

$session_control = 'readonly';
@define('AUTH_HANDLER', true);
@define('JONAH_BASE', dirname(__FILE__) . '/..');
require_once JONAH_BASE . '/lib/base.php';
require_once JONAH_BASE . '/lib/News.php';

$news = &Jonah_News::singleton();

/* Get the id of the channel to display. */
$channel_id = Util::getFormData('channel_id');

/* Fetch the channel info and the story list and check they are both valid.
 * Do a simple exit in case of errors. */
$channel = $news->getChannel($channel_id);
if (is_a($channel, 'PEAR_Error')) {
    Horde::logMessage($channel, __FILE__, __LINE__, PEAR_LOG_ERR);
    exit('invalid channel');
}

$stories = $news->getStories($channel_id, 10, 0, false, time());
if (is_a($stories, 'PEAR_Error')) {
    Horde::logMessage($stories, __FILE__, __LINE__, PEAR_LOG_ERR);
    exit('no stories');
}

$template = &new Horde_Template();
$template->set('charset', NLS::getCharset());
$template->set('channel_name', @htmlspecialchars($channel['channel_name'], ENT_COMPAT, NLS::getCharset()));
$template->set('channel_desc', @htmlspecialchars($channel['channel_desc'], ENT_COMPAT, NLS::getCharset()));
$template->set('channel_updated', @htmlspecialchars(date('r', $channel['channel_updated']), ENT_COMPAT, NLS::getCharset()));
$template->set('channel_url', Util::addParameter(Horde::applicationUrl('delivery/html.php', true, -1), 'channel_id', $channel['channel_id']));
if (empty($channel['channel_story_url'])) {
    $story_url = Horde::applicationUrl('stories/view.php', true, -1);
    $story_url = Util::addParameter($story_url, array('channel_id' => '%c', 'story_id' => '%s'), null, false);
    $story_url = str_replace(array('%25c', '%25s'), array('%c', '%s'), $story_url);
} else {
    $story_url = $channel['channel_story_url'];
}
foreach ($stories as $key => $story) {
    $stories[$key]['story_title'] = @htmlspecialchars($story['story_title'], ENT_COMPAT, NLS::getCharset());
    $stories[$key]['story_desc'] = @htmlspecialchars($story['story_desc'], ENT_COMPAT, NLS::getCharset());
    $stories[$key]['story_link'] = @htmlspecialchars(str_replace(array('%c', '%s'), array($channel_id, $story['story_id']), $story_url), ENT_COMPAT, NLS::getCharset());
}
$template->set('stories', $stories);

header('Content-Type: text/xml');
echo $template->fetch(JONAH_TEMPLATES . '/delivery/rss.xml');
